diff --git a/src/haproxy.c b/src/haproxy.c
index d4658f6055f4..889854ec6065 100644
--- a/src/haproxy.c
+++ b/src/haproxy.c
@@ -3425,6 +3425,8 @@ int main(int argc, char **argv)
 					exit(1); /* there has been an error */
 				}
 				else if (ret == 0) { /* child breaks here */
+                                        /* This one must not be exported, it's internal! */
+                                        unsetenv("HAPROXY_MWORKER_REEXEC");
 					ha_random_jump96(relative_pid);
 					break;
 				}
diff --git a/src/mworker-prog.c b/src/mworker-prog.c
index e77317f44881..126cfab3c2e8 100644
--- a/src/mworker-prog.c
+++ b/src/mworker-prog.c
@@ -110,6 +110,8 @@ int mworker_ext_launch_all()
 					exit(1);
 				}
 
+				/* This one must not be exported, it's internal! */
+				unsetenv("HAPROXY_MWORKER_REEXEC");
 				execvp(child->command[0], child->command);
 
 				ha_alert("Cannot execute %s: %s\n", child->command[0], strerror(errno));
